--------------------------------------------------------------------------------
-- Jupiter-80 Librarian
--
-- Copyright 2014 Kim Sand
--
-- Menu integration code
--------------------------------------------------------------------------------


--------------------------------------------------------------------------------
-- Includes
--------------------------------------------------------------------------------

require "sysex"
require "svdgui"


--------------------------------------------------------------------------------
-- Functions
--------------------------------------------------------------------------------
function add_menu_items()
  renoise.tool():add_menu_entry {
    name = "Main Menu:Tools:Jupiter-80 Librarian:Retrieve list of registrations (MIDI)",
    invoke = function()
      loop_type = Loop_type.Registrations

      local success = connect_to_jupiter()
      if success == false then return end

      print("Looping through registrations.")
      send_jupiter_commands()
    end
  }

  renoise.tool():add_menu_entry {
    name = "Main Menu:Tools:Jupiter-80 Librarian:Retrieve list of live sets (MIDI)",
    invoke = function()
      loop_type = Loop_type.Livesets

      local success = connect_to_jupiter()
      if success == false then return end

      print("Looping through live sets.")
      send_jupiter_commands()
    end
  }

  renoise.tool():add_menu_entry {
    name = "Main Menu:Tools:Jupiter-80 Librarian:Show list of all sounds (SVD)",
    invoke = function()
      build_and_show_overview()
    end
  }

  renoise.tool():add_menu_entry {
    name = "Main Menu:Tools:Jupiter-80 Librarian:Show list of independent sounds (SVD)",
    invoke = function()
      build_and_show_independents()
    end
  }

  renoise.tool():add_menu_entry {
    name = "Main Menu:Tools:Jupiter-80 Librarian:Show dependencies (SVD)",
    invoke = function()
      build_and_show_dependencies()
    end
  }

  renoise.tool():add_menu_entry {
    name = "Main Menu:Tools:Jupiter-80 Librarian:Show inverse dependencies (SVD)",
    invoke = function()
      build_and_show_inverse_dependencies()
    end
  }

  renoise.tool():add_menu_entry {
    name = "Main Menu:Tools:Jupiter-80 Librarian:Re-order registrations (SVD)",
    invoke = function()
      reorder_registrations()
    end
  }

  renoise.tool():add_menu_entry {
    name = "Main Menu:Tools:Jupiter-80 Librarian:Re-order live sets (SVD)",
    invoke = function()
      reorder_live_sets()
    end
  }

  renoise.tool():add_menu_entry {
    name = "Main Menu:Tools:Jupiter-80 Librarian:Re-order tones (SVD)",
    invoke = function()
      reorder_tones()
    end
  }
end
