--------------------------------------------------------------------------------
-- Jupiter-80 Librarian
--
-- Copyright 2014 Kim Sand
--
-- MIDI Interfacing
--------------------------------------------------------------------------------


--------------------------------------------------------------------------------
-- Variables
--------------------------------------------------------------------------------
midi_in = nil  --device
midi_out = nil --device


--------------------------------------------------------------------------------
-- Functions
--------------------------------------------------------------------------------
function midi_in_connect(device)
  -- Connect to a specified midi device for receiving data
  midi_in = renoise.Midi.create_input_device(device, midi_callback, my_sysex_callback)

  local message
  if midi_in then
    message = "SysEx Handler (receive) connected to " .. device .. " successfully."
    print(message)
    --renoise.app():show_status(message)
    return true
  else
    message = "SysEx Handler (receive) connection to " .. device .. " failed."
    print(message)
    renoise.app():show_status(message)
    return false
  end
end


function midi_in_disconnect()
  -- Disconnect the receiving device
  if midi_in then
    midi_in:close()
    midi_in = nil
  end
  local message = "SysEx Handler (receive) disconnected."
  print(message)
  --renoise.app():show_status(message)
end


function midi_out_connect(device)
  -- Connect to a specified midi device for sending data
  midi_out = renoise.Midi.create_output_device(device)

  local message
  if not midi_out then
    midi_in:close()
    message = "SysEx Handler connection to " .. device .. " failed."
    print(message)
    renoise.app():show_status(message)
    return false
  end

  message = "SysEx Handler (send) connected to " .. device .. " successfully."
  print(message)
  --renoise.app():show_status(message)
  return true
end


function midi_out_disconnect()
  -- Disconnect the sending device
  if midi_out then
    midi_out:close()
    midi_out = nil
  end
  local message = "SysEx Handler (send) disconnected."
  print(message)
  --renoise.app():show_status(message)
end


function midi_callback(message)
  -- No action / handling required
end
