--------------------------------------------------------------------------------
-- Jupiter-80 Librarian
--
-- Copyright 2014 Kim Sand
--
-- SVD common variables and functions
--------------------------------------------------------------------------------


--------------------------------------------------------------------------------
-- Variables
--------------------------------------------------------------------------------

File_format = {Unknown=0, Jupiter80=1, Jupiter50=2}
init_reg_name = "INIT REGIST"
init_live_name = "INIT LIVESET"
init_tone_name = "INIT SYNTH"

file_format = nil

filenamepath = nil
filename = nil

svd_text = nil
overview_text = nil
independents_text = nil
dependencies_text = nil
inv_dependencies_text = nil

reg_name_table = nil
live_name_table = nil
tone_name_table = nil

live_reg_map = nil
tone_live_map = nil
tone_reg_map = nil

header_offset = nil

reg_offset = nil
reg_len = nil
live_offset = nil
live_meta_len = nil
live_len = nil
tone_offset = nil
tone_meta_len = nil
tone_len = nil

reg_upper_offset = nil
reg_lower_offset = nil
reg_solo_offset = nil
reg_perc_offset = nil

reg_upper_type_offset = nil
reg_lower_type_offset = nil
reg_solo_type_offset = nil
reg_perc_type_offset = nil

nr_of_regs = nil
nr_of_lives = nil
nr_of_tones = nil

nr_of_regs_offset = nil
nr_of_lives_offset = nil
nr_of_tones_offset = nil

swap_from_part = nil
swap_to_part = nil
part_buttons = nil

dialog_window = nil
matrix_page = nil

--------------------------------------------------------------------------------
-- Functions
--------------------------------------------------------------------------------

function init_svd_variables()
	file_format = File_format.Unknown

	filenamepath = nil
	filename = nil

	svd_text = nil
	overview_text = nil
	independents_text = nil
	dependencies_text = nil
	inv_dependencies_text = nil

	reg_name_table = {}
	live_name_table = {}
	tone_name_table = {}

	live_reg_map = {}
	tone_live_map = {}
	tone_reg_map = {}

	header_offset = 0

	reg_offset = 0x50
	reg_len = 0x2f4
	live_offset = nil
	live_meta_len = 0x0c
	live_len = 0x48e
	tone_offset = nil
	tone_meta_len = 0x0c
	tone_len = 0xa8

	reg_upper_offset = 0x85
	reg_lower_offset = 0x8C
	reg_solo_offset = 0x93
	reg_perc_offset = 0x9A

	reg_upper_type_offset = 0x84
	reg_lower_type_offset = 0x8B
	reg_solo_type_offset = 0x92
	reg_perc_type_offset = 0x99

	nr_of_regs = nil
	nr_of_lives = nil
	nr_of_tones = nil

	nr_of_regs_offset = 0x40
	nr_of_lives_offset = nil
	nr_of_tones_offset = nil

	swap_from_part = nil
	swap_to_part = nil
	part_buttons = {}

	matrix_page = 1
end
